from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Directory, File, Array, String, Int, Boolean

Msstitch_Merge_V0_1_0 = CommandToolBuilder(tool="msstitch_merge", base_command=["msstitch", "merge"], inputs=[ToolInput(tag="in_directory_to_output", input_type=Directory(optional=True), prefix="-d", doc=InputDocumentation(doc="Directory to output in")), ToolInput(tag="in_output_file", input_type=File(optional=True), prefix="-o", doc=InputDocumentation(doc="Output file")), ToolInput(tag="in_set_names", input_type=Array(t=String(), optional=True), prefix="--setnames", doc=InputDocumentation(doc="Names of biological sets. Can be specified with\nquotation marks if spaces are used")), ToolInput(tag="in_is_ob_quant_col_pattern", input_type=String(optional=True), prefix="--isobquantcolpattern", doc=InputDocumentation(doc="Unique text pattern to identify isobaric quant columns\nin input table.")), ToolInput(tag="in_psm_nr_col_pattern", input_type=Int(optional=True), prefix="--psmnrcolpattern", doc=InputDocumentation(doc="Unique text pattern to identify number-of-psms column\nin input table.")), ToolInput(tag="in_ms_one_quant_col_pattern", input_type=Int(optional=True), prefix="--ms1quantcolpattern", doc=InputDocumentation(doc="Unique text pattern to identify precursor quant column\nin input table.")), ToolInput(tag="in_fdr_col_pattern", input_type=String(optional=True), prefix="--fdrcolpattern", doc=InputDocumentation(doc="Unique text pattern to identify FDR column in input\ntable.")), ToolInput(tag="in_multiple_input_files", input_type=Array(t=String(), optional=True), prefix="-i", doc=InputDocumentation(doc="Multiple input files of {} format")), ToolInput(tag="in_feat_col", input_type=Int(optional=True), prefix="--featcol", doc=InputDocumentation(doc="Column number in table in which protein or gene\naccessions are. stored. First column number is 1. Use\nin case of not using standard first column")), ToolInput(tag="in_dbfile", input_type=File(optional=True), prefix="--dbfile", doc=InputDocumentation(doc="Database lookup file")), ToolInput(tag="in_merge_cut_off", input_type=String(optional=True), prefix="--mergecutoff", doc=InputDocumentation(doc="FDR cutoff when building merged protein table, to use\nwhen a cutoff has been used before storing the table\nto lookup. FDR values need to be stored in the lookup")), ToolInput(tag="in_no_group_annotation", input_type=Boolean(optional=True), prefix="--no-group-annotation", doc=InputDocumentation(doc="For peptide table merging. Do not include protein\ngroup or gene data in output, just use accessions.")), ToolInput(tag="in_gene_centric", input_type=Boolean(optional=True), prefix="--genecentric", doc=InputDocumentation(doc="For peptide table merging. Do not include protein\ngroup data in output, but use gene names instead to\ncount peptides per feature, determine peptide-\nuniqueness.\n"))], outputs=[ToolOutput(tag="out_directory_to_output", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_directory_to_output", type_hint=File()), doc=OutputDocumentation(doc="Directory to output in")), ToolOutput(tag="out_output_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_file", type_hint=File()), doc=OutputDocumentation(doc="Output file"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Msstitch_Merge_V0_1_0().translate("wdl", allow_empty_container=True)

